fstests.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
* [RFC PATCH] generic: test PF_MEMALLOC interfering with accounting file write
@ 2020-03-12 22:14 Eric Biggers
  2020-03-12 22:30 ` Darrick J. Wong
  0 siblings, 1 reply; 2+ messages in thread
From: Eric Biggers @ 2020-03-12 22:14 UTC (permalink / raw)
  To: fstests; +Cc: linux-xfs

From: Eric Biggers <ebiggers@google.com>

Add a regression test for the bug fixed by commit 10a98cb16d80 ("xfs:
clear PF_MEMALLOC before exiting xfsaild thread").

Signed-off-by: Eric Biggers <ebiggers@google.com>
---

RFC for now since the commit is in xfs/for-next only, and I'm not sure
the commit ID is stable.

 common/config         |  1 +
 common/rc             | 11 ++++++++
 tests/generic/901     | 60 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/901.out |  2 ++
 tests/generic/group   |  1 +
 5 files changed, 75 insertions(+)
 create mode 100644 tests/generic/901
 create mode 100644 tests/generic/901.out

diff --git a/common/config b/common/config
index 1116cb995..8023273da 100644
--- a/common/config
+++ b/common/config
@@ -220,6 +220,7 @@ export DUPEREMOVE_PROG="$(type -P duperemove)"
 export CC_PROG="$(type -P cc)"
 export FSVERITY_PROG="$(type -P fsverity)"
 export OPENSSL_PROG="$(type -P openssl)"
+export ACCTON_PROG="$(type -P accton)"
 
 # use 'udevadm settle' or 'udevsettle' to wait for lv to be settled.
 # newer systems have udevadm command but older systems like RHEL5 don't.
diff --git a/common/rc b/common/rc
index 454f5ccf5..0bc4b14f2 100644
--- a/common/rc
+++ b/common/rc
@@ -4168,6 +4168,17 @@ _check_xfs_scrub_does_unicode() {
 	return 0
 }
 
+# Require the 'accton' userspace tool and CONFIG_BSD_PROCESS_ACCT=y.
+_require_bsd_process_accounting()
+{
+	_require_command "$ACCTON_PROG" accton
+	$ACCTON_PROG on &> $tmp.test_accton
+	cat $tmp.test_accton >> $seqres.full
+	if grep 'Function not implemented' $tmp.test_accton; then
+		_notrun "BSD process accounting support unavailable"
+	fi
+}
+
 init_rc
 
 ################################################################################
diff --git a/tests/generic/901 b/tests/generic/901
new file mode 100644
index 000000000..c59300f1b
--- /dev/null
+++ b/tests/generic/901
@@ -0,0 +1,60 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright 2020 Google LLC
+#
+# FS QA Test No. 901
+#
+# Regression test for the bug fixed by commit 10a98cb16d80 ("xfs: clear
+# PF_MEMALLOC before exiting xfsaild thread").  If the bug exists, a kernel
+# WARNING should be triggered.  See the commit message for details.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	$ACCTON_PROG off >> $seqres.full
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_bsd_process_accounting
+_require_chattr S
+_require_test
+_require_scratch
+
+# To trigger the bug we must unmount a filesystem while BSD process accounting
+# is enabled.  The accounting file must also be located on a different
+# filesystem and have the sync flag set.
+
+accounting_file=$TEST_DIR/$seq
+
+rm -f $accounting_file
+touch $accounting_file
+$CHATTR_PROG +S $accounting_file
+
+_scratch_mkfs &>> $seqres.full
+$ACCTON_PROG $accounting_file >> $seqres.full
+_scratch_mount
+_scratch_unmount
+$ACCTON_PROG off >> $seqres.full
+
+echo "Silence is golden"
+
+status=0
+exit
diff --git a/tests/generic/901.out b/tests/generic/901.out
new file mode 100644
index 000000000..b206bc11d
--- /dev/null
+++ b/tests/generic/901.out
@@ -0,0 +1,2 @@
+QA output created by 901
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index dc95b77b3..61a679793 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -595,3 +595,4 @@
 591 auto quick rw pipe splice
 592 auto quick encrypt
 593 auto quick encrypt
+901 auto quick
-- 
2.25.1


^ permalink raw reply related	[flat|nested] 2+ messages in thread

end of thread, other threads:[~2020-03-12 22:30 UTC | newest]

Thread overview: 2+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-03-12 22:14 [RFC PATCH] generic: test PF_MEMALLOC interfering with accounting file write Eric Biggers
2020-03-12 22:30 ` Darrick J. Wong

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).